/*******************************************************************
 * This file is part of the Emulex Linux Device Driver for         *
 * Fibre Channel Host Bus Adapters.                                *
 * Copyright (C) 2003-2006 Emulex.  All rights reserved.           *
 * EMULEX and SLI are trademarks of Emulex.                        *
 * www.emulex.com                                                  *
 *                                                                 *
 * This program is free software; you can redistribute it and/or   *
 * modify it under the terms of version 2 of the GNU General       *
 * Public License as published by the Free Software Foundation.    *
 * This program is distributed in the hope that it will be useful. *
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND          *
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE      *
 * DISCLAIMED, EXCEPT TO THE EXTENT THAT SUCH DISCLAIMERS ARE HELD *
 * TO BE LEGALLY INVALID.  See the GNU General Public License for  *
 * more details, a copy of which can be found in the file COPYING  *
 * included with this package.                                     *
 *******************************************************************/

/* 
 * $Id: mpl_crtn.h 1027 2006-04-07 23:26:53Z jinfante $
 */

extern void mpl_module_lock(void);
extern void mpl_module_unlock(void);
extern int mpl_vendor_hp_check(struct scsi_cmnd *);
extern void mpl_restart_sched_cmd(struct mpl_path *, unsigned long);
extern void mpl_restart_pendq_timer(struct mpl_device *, unsigned long);
extern void mpl_set_cmd_path(struct scsi_cmnd *, struct mpl_path *);
extern void mpl_cmd_timeout(unsigned long);
extern struct io_stub *mpl_setup_inquiry(struct mpl_path *, unsigned char);
extern struct io_stub *mpl_setup_startstop(struct mpl_path *);
extern struct io_stub *mpl_setup_tur(struct mpl_path *);
extern struct io_stub *mpl_setup_report_tgt_port(struct mpl_path *);
extern struct io_stub *mpl_setup_set_tgt_port(struct mpl_path *, int, int);
extern void mpl_send_internal_cmd(struct mpl_path *, struct io_stub *);
extern void mpl_send_internal_completion(struct mpl_path *, struct io_stub *,
					 void (*done)(struct scsi_cmnd *));
extern void mpl_path_schedule_cmd(unsigned long);
extern void mpl_path_set_active(struct mpl_path *, int);
extern void mpl_path_flip_all_active(struct mpl_path *);
extern void mpl_device_process_pendq(struct mpl_device *);
extern void mpl_pendq_timeout_fn(unsigned long);
extern void mpl_process_internal_cmd(struct io_stub *);
extern void mpl_process_hbeat_cmd(struct io_stub *);
extern char *mpl_print_host(struct mpl_host *);
extern char *mpl_print_device(struct mpl_device *);
extern char *mpl_print_path(struct mpl_path *);
extern void  mpl_hbeat_state_machine(struct mpl_path *,
				     enum mpl_hb_event event);
extern void mpl_path_state_machine(struct mpl_path *, enum mpl_path_event);
extern void mpl_device_state_machine(struct mpl_device *,
				     struct mpl_path *,
				     enum mpl_device_event);

extern struct io_stub *mpl_find_stub_remove(struct scsi_cmnd *);
extern struct io_stub *mpl_find_stub_remove_quiet(struct scsi_cmnd *);
extern int    mpl_find_stub_in_hash(struct io_stub *);
extern struct io_stub *mpl_get_first_pend_io(struct mpl_device *);
extern void mpl_inc_can_queue(struct io_stub *);
extern void  mpl_dec_can_queue(struct io_stub *);
extern void mpl_done(struct scsi_cmnd *);
extern void mpl_internal_done(struct scsi_cmnd *);
extern int (*mpl_base_queuecommand)(struct scsi_cmnd *, void (*done)(struct scsi_cmnd *));
extern void mpl_set_cmd_timer(struct io_stub *, int);
extern char *mpl_print_wwpn(unsigned char *);
extern int mpl_get_tgt_wwinfo(struct lpfc_hba *, uint32_t, uint8_t *, uint8_t *);
extern int mpl_host_is_offline(struct lpfc_hba *);
extern void mpl_get_hba_wwpn(struct lpfc_hba *, uint8_t *);
extern int mpl_get_validation_id(char *, char *, int *);
extern int mpl_get_scsi_page83_serial(char *, struct scsi_id_search_values *,
		int, char *, int *);
extern int mpl_crack_serial_number(uint8_t *, size_t, char *);
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0)
extern unsigned short mpl_get_lun_q_depth(struct mpl_host *);
#endif
extern void mpl_free_initial_data(void);
extern int mpl_get_path_flags(int *flags, uint8_t host_wwpn[8],
			      uint8_t target_wwpn[8], int lun);
extern int mpl_get_device_flags_by_path(int *flags, uint8_t host_wwpn[8],
					uint8_t target_wwpn[8], int lun);

